//---------------------------------------------------------------------------
#ifndef Moochos_Moa_Clipboard_H
#define Moochos_Moa_Clipboard_H
//---------------------------------------------------------------------------
// Clipboard.h
//
// Version: 1.1.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Clipboard {
//---------------------------------------------------------------------------
class EClipboardError : public Exception
{
public:
	__fastcall EClipboardError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TClipboardWatcher : public TObject
	// Watches the clipboard and notifies of its changes.
{
private:
	HWND FHandle;
	HWND FNextHandle;
	bool FEnabled;
	TNotifyEvent FOnChange;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall HandleMessage(TMessage& AMessage);
	void __fastcall WMChangeCbChain(TMessage& AMessage);
	void __fastcall WMDrawClipboard(TMessage& AMessage);
	void __fastcall DoChange();
	void __fastcall SetEnabled(bool AEnabled);
protected:
public:
	__fastcall TClipboardWatcher();
	virtual __fastcall ~TClipboardWatcher();
	__property bool Enabled = {read=FEnabled, write=SetEnabled};
	__property TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};
//---------------------------------------------------------------------------
}}} // End of Moochos::Moa::Clipboard
using namespace Moochos::Moa::Clipboard;
//---------------------------------------------------------------------------
#endif

