//---------------------------------------------------------------------------
// Controls2.cpp
//
// Version: 1.1.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Controls2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Controls2 {
//---------------------------------------------------------------------------
void __fastcall TLateExecutor::Initialize()
{
	try {
		FHandle = AllocateHWnd(HandleMessage);
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TLateExecutor::Uninitialize()
{
	if(FHandle != NULL) {
		DeallocateHWnd(FHandle);
		FHandle = NULL;
	}
}
//---------------------------------------------------------------------------
void __fastcall TLateExecutor::HandleMessage(TMessage& AMessage)
{
	switch(AMessage.Msg) {
	case WM_EXECUTE:
		WMExecute(AMessage);
		break;
	default:
		AMessage.Result = DefWindowProc(FHandle, AMessage.Msg, AMessage.WParam, AMessage.LParam);
		break;
	}
}
//---------------------------------------------------------------------------
void __fastcall TLateExecutor::WMExecute(TMessage& AMessage)
{
	FExecuting = false;
	DoExecute();
}
//---------------------------------------------------------------------------
void __fastcall TLateExecutor::DoExecute()
{
	if(OnExecute != NULL) {
		OnExecute(NULL);
	}
}
//---------------------------------------------------------------------------
__fastcall TLateExecutor::TLateExecutor() :
	TObject(),
	FHandle(NULL),
	FExecuting(false),
	FOnExecute(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TLateExecutor::~TLateExecutor()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
void __fastcall TLateExecutor::Execute()
{
	if(IsExecuting()) {
		return;
	}
	PostMessage(FHandle, WM_EXECUTE, 0, 0);
	FExecuting = true;
}
//---------------------------------------------------------------------------
void __fastcall TLateExecutor::Cancel()
{
	MSG msg = {0};
	PeekMessage(&msg, FHandle, WM_EXECUTE, WM_EXECUTE, PM_REMOVE);
	FExecuting = false;
}
//---------------------------------------------------------------------------
bool __fastcall TLateExecutor::IsExecuting()
{
	return FExecuting;
}
//---------------------------------------------------------------------------
__fastcall TAutoControlVisible::TAutoControlVisible(TControl* AControl, bool AVisible) :
	FControl(AControl),
	FVisible(AControl->Visible)
{
	FControl->Visible = AVisible;
}
//---------------------------------------------------------------------------
__fastcall TAutoControlVisible::~TAutoControlVisible()
{
	FControl->Visible = FVisible;
}
//---------------------------------------------------------------------------
__fastcall TAutoControlEnabled::TAutoControlEnabled(TControl* AControl, bool AEnabled) :
	FControl(AControl),
	FEnabled(AControl->Enabled)
{
	FControl->Enabled = AEnabled;
}
//---------------------------------------------------------------------------
__fastcall TAutoControlEnabled::~TAutoControlEnabled()
{
	FControl->Enabled = FEnabled;
}
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Moa::Controls2
//---------------------------------------------------------------------------

