//---------------------------------------------------------------------------
#ifndef Moochos_Moa_Controls2_H
#define Moochos_Moa_Controls2_H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
// Controls2.h
//
// Version: 1.1.0
// Author: Moochos
// Note: "Controls2" is named to avoid errors. With the name "Controls", the
//   application can be built, but it stops in errors.
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Controls2 {
//---------------------------------------------------------------------------
class TLateExecutor : public TObject
	// Postpones the execution of some task until all messages currently in
	// the queue are consumed.
{
private:
	static const UINT WM_EXECUTE = WM_APP + 0;
	HWND FHandle;
	bool FExecuting;
	TNotifyEvent FOnExecute;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall HandleMessage(TMessage& AMessage);
	void __fastcall WMExecute(TMessage& AMessage);
	void __fastcall DoExecute();
protected:
public:
	__fastcall TLateExecutor();
	virtual __fastcall ~TLateExecutor();
	void __fastcall Execute();
	void __fastcall Cancel();
	bool __fastcall IsExecuting();
	__property TNotifyEvent OnExecute = {read=FOnExecute, write=FOnExecute};
};
//---------------------------------------------------------------------------
class TAutoControlVisible
	// Temporarily changes Visible of a control until this object is freed.
{
private:
	TControl* FControl;
	bool FVisible;
	__fastcall TAutoControlVisible(const TAutoControlVisible& AOther); // Forbidden
	TAutoControlVisible& __fastcall operator =(const TAutoControlVisible& AOther); // Forbidden
protected:
public:
	__fastcall TAutoControlVisible(TControl* AControl, bool AVisible);
	__fastcall ~TAutoControlVisible();
};
//---------------------------------------------------------------------------
class TAutoControlEnabled
	// Temporarily changes Enabled of a control until this object is freed.
{
private:
	TControl* FControl;
	bool FEnabled;
	__fastcall TAutoControlEnabled(const TAutoControlEnabled& AOther); // Forbidden
	TAutoControlEnabled& __fastcall operator =(const TAutoControlEnabled& AOther); // Forbidden
protected:
public:
	__fastcall TAutoControlEnabled(TControl* AControl, bool AEnabled);
	__fastcall ~TAutoControlEnabled();
};
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Moa::Controls2
using namespace Moochos::Moa::Controls2;
//---------------------------------------------------------------------------
#endif

