//---------------------------------------------------------------------------
#ifndef Moochos_Moa_Files_H
#define Moochos_Moa_Files_H
//---------------------------------------------------------------------------
// Files.h
//
// Version: 1.1.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Files {
//---------------------------------------------------------------------------
class EFileError : public Exception
{
public:
	__fastcall EFileError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TFileInfoEnumerator
	// Enumerates file informations.
{
private:
	HANDLE FHandle;
	WIN32_FIND_DATA FData;
	bool FFound;
	__fastcall TFileInfoEnumerator(const TFileInfoEnumerator& AOther); // Forbidden
	TFileInfoEnumerator& __fastcall operator =(const TFileInfoEnumerator& AOther); // Forbidden
	void __fastcall FindFirst(const AnsiString& AFileName);
	void __fastcall FindNext();
	void __fastcall FindClose();
protected:
public:
	__fastcall TFileInfoEnumerator(const AnsiString& AFileName);
	__fastcall ~TFileInfoEnumerator();
	bool __fastcall HasNext();
	WIN32_FIND_DATA __fastcall GetNext();
};
//---------------------------------------------------------------------------
extern AnsiString __fastcall ExtractLongPathName(const AnsiString AFileName);
extern bool __fastcall DriveExists(const AnsiString& AFileName);
extern bool __fastcall FileOrDirExists(const AnsiString& AFileName);
extern bool __fastcall IsFileNameMask(const AnsiString& AFileName);
extern bool __fastcall IsAbsoluteFileName(const AnsiString& AFileName);
extern bool __fastcall IsRelativeFileName(const AnsiString& AFileName);
extern bool __fastcall IsDirectory(const WIN32_FIND_DATA& AFindData);
extern bool __fastcall IsDotFileName(const WIN32_FIND_DATA& AFindData);
extern bool __fastcall IsDotDotFileName(const WIN32_FIND_DATA& AFindData);
//---------------------------------------------------------------------------
}}} // End of Moochos::Moa::Files
using namespace Moochos::Moa::Files;
//---------------------------------------------------------------------------
#endif

