//---------------------------------------------------------------------------
#ifndef Moochos_Moa_Hash_H
#define Moochos_Moa_Hash_H
//---------------------------------------------------------------------------
// Hash.h
//
// Version: 1.1.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Hash {
//---------------------------------------------------------------------------
class EHashError : public Exception
{
public:
	__fastcall EHashError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TCrc32Checksum
	// Calculates a CRC32 checksum.
{
private:
	static const unsigned int FTable[256];
	static const unsigned int FMask;
	unsigned int FCurrent;
	__fastcall TCrc32Checksum(const TCrc32Checksum& AOther); // Forbidden
	TCrc32Checksum& __fastcall operator =(const TCrc32Checksum& AOther); // Forbidden
	int __fastcall GetValue();
protected:
public:
	__fastcall TCrc32Checksum();
	__fastcall ~TCrc32Checksum();
	TCrc32Checksum& __fastcall Update(const AnsiString& AData);
	TCrc32Checksum& __fastcall Update(const void* AData, int ALength);
	void __fastcall Reset();
	__property int Value = {read=GetValue};
};
//---------------------------------------------------------------------------
}}} // End of Moochos::Moa::Hash
using namespace Moochos::Moa::Hash;
//---------------------------------------------------------------------------
#endif

