//---------------------------------------------------------------------------
// Lists.cpp
//
// Version: 1.1.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <UtilCls.h>
#include "Lists.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Lists {
//---------------------------------------------------------------------------
void __fastcall AddItems(TList* ASrcList, TList* ADstList)
{
	if(ADstList->Capacity < ADstList->Count + ASrcList->Count) {
		ADstList->Capacity = ADstList->Count + ASrcList->Count;
	}
	for(int i = 0; i < ASrcList->Count; i++) {
		ADstList->Add(ASrcList->Items[i]);
	}
}
//---------------------------------------------------------------------------
void __fastcall Invert(TList* AList)
{
	for(int i = 0; i < AList->Count / 2; i++) {
		AList->Exchange(i, AList->Count - 1 - i);
	}
}
//---------------------------------------------------------------------------
__fastcall TAutoObjectListOwnsObjects::TAutoObjectListOwnsObjects(TObjectList* AList, bool AOwnsObjects) :
	FList(AList),
	FOwnsObjects(AList->OwnsObjects)
{
	FList->OwnsObjects = AOwnsObjects;
}
//---------------------------------------------------------------------------
__fastcall TAutoObjectListOwnsObjects::~TAutoObjectListOwnsObjects()
{
	FList->OwnsObjects = FOwnsObjects;
}
//---------------------------------------------------------------------------
__fastcall TAutoStringsUpdate::TAutoStringsUpdate(TStrings* AList) :
	FList(AList)
{
	FList->BeginUpdate();
}
//---------------------------------------------------------------------------
__fastcall TAutoStringsUpdate::~TAutoStringsUpdate()
{
	FList->EndUpdate();
}
//---------------------------------------------------------------------------
void __fastcall PackByString(TStrings* ASrcList, TStrings* ADstList)
{
	struct Local
	{
		static bool __fastcall CanDelete(TStrings* AList, int AIndex, void* AData)
		{
			return AList->Strings[AIndex].Length() == 0;
		}
	};

	PackBy(ASrcList, ADstList, Local::CanDelete, NULL);
}
//---------------------------------------------------------------------------
void __fastcall PackByObject(TStrings* ASrcList, TStrings* ADstList)
{
	struct Local
	{
		static bool __fastcall CanDelete(TStrings* AList, int AIndex, void* AData)
		{
			return AList->Objects[AIndex] == NULL;
		}
	};

	PackBy(ASrcList, ADstList, Local::CanDelete, NULL);
}
//---------------------------------------------------------------------------
void __fastcall PackBy(TStrings* ASrcList, TStrings* ADstList, bool __fastcall (* ACanDeleteProc)(TStrings* AList, int AIndex, void* AData), void* AData)
{
	TPtr<TStrings> newList = new TStringList();
	newList->Capacity = ASrcList->Count;
	for(int i = 0; i < ASrcList->Count; i++) {
		if(ACanDeleteProc(ASrcList, i, AData)) {
			continue;
		}
		newList->AddObject(ASrcList->Strings[i], ASrcList->Objects[i]);
	}
	ADstList->Assign(newList);
}
//---------------------------------------------------------------------------
void __fastcall Invert(TStrings* AList)
{
	for(int i = 0; i < AList->Count / 2; i++) {
		AList->Exchange(i, AList->Count - 1 - i);
	}
}
//---------------------------------------------------------------------------
}}} // End of Moochos::Moa::Lists
//---------------------------------------------------------------------------

